edu.sc.seis.sod.source.event

## Class BackwardsEventFinder

- java.lang.Object
- - edu.sc.seis.sod.source.AbstractSource
  - - edu.sc.seis.sod.source.event.EventFinder
    - - edu.sc.seis.sod.source.event.BackwardsEventFinder

- All Implemented Interfaces:
    EventSource, Source

      public class BackwardsEventFinder
      extends EventFinder

- - ### Field Summary

    - ### Fields inherited from class edu.sc.seis.sod.source.event.EventFinder

      `increment, lag, refreshInterval`

    - ### Fields inherited from class edu.sc.seis.sod.source.AbstractSource

      `name, NAME_ELEMENT, RETRIES_ELEMENT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BackwardsEventFinder(org.w3c.dom.Element config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `caughtUpWithRealtime()`
    `java.lang.String` | `getDescription()`
    `protected edu.iris.Fissures.model.MicroSecondDate` | `getQueryStart()`
    `protected edu.sc.seis.fissuresUtil.time.MicroSecondTimeRange` | `getQueryTime()`
    `boolean` | `hasNext()`
    `edu.sc.seis.fissuresUtil.cache.CacheEvent[]` | `next()`
    `protected void` | `updateQueryEdge(edu.sc.seis.fissuresUtil.time.MicroSecondTimeRange queryTime)`

    - ### Methods inherited from class edu.sc.seis.sod.source.event.EventFinder

      `getDNS, getEventTimeRange, getQueryEdge, getWaitBeforeNext, processConfig, setQueryEdge`

    - ### Methods inherited from class edu.sc.seis.sod.source.AbstractSource

      `appendToName, getFissuresNamingService, getName, getRetries, getRetryStrategy, setRetryStrategy`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface edu.sc.seis.sod.source.Source

      `appendToName, getName, getRetries`

- - ### Constructor Detail

    - #### BackwardsEventFinder

          public BackwardsEventFinder(org.w3c.dom.Element config)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

  - ### Method Detail

    - #### getDescription

          public java.lang.String getDescription()

      Specified by:
        `getDescription` in interface `EventSource`
      Overrides:
        `getDescription` in class `EventFinder`

    - #### hasNext

          public boolean hasNext()

      Specified by:
        `hasNext` in interface `EventSource`
      Overrides:
        `hasNext` in class `EventFinder`
      Returns:
        - false when this event source will return no new events from calls to next

    - #### next

          public edu.sc.seis.fissuresUtil.cache.CacheEvent[] next()

      Specified by:
        `next` in interface `EventSource`
      Overrides:
        `next` in class `EventFinder`
      Returns:
        - the next set of events. Events can be returned from this method multiple times

    - #### caughtUpWithRealtime

          protected boolean caughtUpWithRealtime()

      Overrides:
        `caughtUpWithRealtime` in class `EventFinder`

    - #### updateQueryEdge

          protected void updateQueryEdge(edu.sc.seis.fissuresUtil.time.MicroSecondTimeRange queryTime)

      Overrides:
        `updateQueryEdge` in class `EventFinder`

    - #### getQueryStart

          protected edu.iris.Fissures.model.MicroSecondDate getQueryStart()

      Overrides:
        `getQueryStart` in class `EventFinder`
      Returns:
        - the next time to start asking for events

    - #### getQueryTime

          protected edu.sc.seis.fissuresUtil.time.MicroSecondTimeRange getQueryTime()

      Overrides:
        `getQueryTime` in class `EventFinder`
      Returns:
        - the next time range to be queried for events